//--------------------------------------------------------------------
//                                                                    
//  Module:       CompDragAndDrop                                       
//  Description:  CompDragAndDrop
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class CompDragAndDrop extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPDragItem DragAndDrop1;
	JDPChiselFramePanel ChiselPanel1;
	Panel Panel2;
	Panel Panel1;
	Button Button1;
	Button Button2;
	Button Button3;
	Button Button4;
	Button Button5;
	TextArea TextArea1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		DragAndDrop1 = new JDPDragItem(user.getJDPUser(), Main);
		ChiselPanel1 = new JDPChiselFramePanel(user, "Component Drag and Drop demo");
		Panel2 = new Panel();
		Panel1 = new Panel();
		Button1 = new Button("Button1");
		Button2 = new Button("Button2");
		Button3 = new Button("Button3");
		Button4 = new Button("Button4");
		Button5 = new Button("Button5");
		TextArea1 = new TextArea("", 3,20);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", DragAndDrop1);
		Main.add("Center", ChiselPanel1);
		ChiselPanel1.add("Center", Panel2);
		Panel2.setLayout(new BorderLayout());
		Panel2.add("North", Panel1);
		Panel1.setLayout(new GridLayout(1,5));
		Panel1.add(Button1);
		Panel1.add(Button2);
		Panel1.add(Button3);
		Panel1.add(Button4);
		Panel1.add(Button5);
		Panel2.add("Center", TextArea1);

		Button1.disable();
		Button1.disable();
		Button2.disable();
		Button2.disable();
		Button3.disable();
		Button3.disable();
		Button4.disable();
		Button4.disable();
		Button5.disable();
		Button5.disable();
		TextArea1.setText("Drag a button and drop it on this textarea");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(DragAndDrop1)) {
				Component comp = DragAndDrop1.getDraggedComponent();
				if (comp != null && comp instanceof Button) {
					TextArea1.setText(((Button)comp).getLabel());
				}
				if (comp != null && comp instanceof JDPButton) {
					TextArea1.setText(((JDPButton)comp).getLabel());
				}
				
				return true;
			}
			return false;

		case Event.MOUSE_DRAG:
			if (e.target.equals(Panel1)) {
				DragAndDrop1.postEvent(e);
				return true;
			}
			return false;

		case Event.MOUSE_UP:
			if (e.target.equals(Panel1)) {
				if (DragAndDrop1.isVisible()) {
					DragAndDrop1.postEvent(e);
				}
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		DragAndDrop1.addDragComponent(Button1,Panel1,"DragButton");
		DragAndDrop1.addDragComponent(Button2,Panel1,"DragButton");
		DragAndDrop1.addDragComponent(Button3,Panel1,"DragButton");
		DragAndDrop1.addDragComponent(Button4,Panel1,"DragButton");
		DragAndDrop1.addDragComponent(Button5,Panel1,"DragButton");
		DragAndDrop1.addDropComponent(TextArea1,Panel2,"DragButton","Drop Here");

	}

}

