//--------------------------------------------------------------------
//                                                                    
//  Module:       FileDragAndDrop                                       
//  Description:  FileDragAndDrop
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class FileDragAndDrop extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPDragItem DragAndDrop1;
	JDPChiselFramePanel ChiselPanel1;
	Panel Panel1;
	Panel Panel2;
	JDPFilePicker FilePicker1;
	Label Label1;
	Panel Panel3;
	JDPFilePicker FilePicker2;
	Label Label2;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		DragAndDrop1 = new JDPDragItem(user.getJDPUser(), Main);
		ChiselPanel1 = new JDPChiselFramePanel(user, "Drag and Drop demo (no files actually get copied or moved)");
		Panel1 = new Panel();
		Panel2 = new Panel();
		FilePicker1 = new JDPFilePicker();
		FilePicker1.InitClass(user, targetPanel, moduleParameter);
		Label1 = new Label("Drag from here", Label.LEFT);
		Panel3 = new Panel();
		FilePicker2 = new JDPFilePicker();
		FilePicker2.InitClass(user, targetPanel, moduleParameter);
		Label2 = new Label("To here", Label.LEFT);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", DragAndDrop1);
		Main.add("Center", ChiselPanel1);
		ChiselPanel1.add("Center", Panel1);
		Panel1.setLayout(new GridLayout(1,2));
		Panel1.add(Panel2);
		Panel2.setLayout(new BorderLayout());
		Panel2.add("Center", FilePicker1);
		Panel2.add("North", Label1);
		Panel1.add(Panel3);
		Panel3.setLayout(new BorderLayout());
		Panel3.add("Center", FilePicker2);
		Panel3.add("North", Label2);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(DragAndDrop1)) {
				String fromFile = null;
				String fileName = "";
				String toFile = null;
				
				JDPTreeBranch[] dragBranch = DragAndDrop1.getDraggedBranch(FilePicker1.List1);
				if (dragBranch != null) {
					fromFile = FilePicker1.getFilePath(dragBranch[dragBranch.length-1]);
					fileName = dragBranch[dragBranch.length-1].name;
				} else {
					dragBranch = DragAndDrop1.getDraggedBranch(FilePicker2.List1);
					if (dragBranch != null) {
						fromFile = FilePicker2.getFilePath(dragBranch[dragBranch.length-1]);
						fileName = dragBranch[dragBranch.length-1].name;
					}
				}
				
				JDPTreeBranch[] dropBranch = DragAndDrop1.getDroppedBranch(FilePicker1.TreeStructure1);
				if (dropBranch != null) {
					toFile = FilePicker1.getDirectoryPath(dropBranch[dropBranch.length-1]) + FilePicker1.getSeparator() + fileName;
				} else {
					dropBranch = DragAndDrop1.getDroppedBranch(FilePicker2.TreeStructure1);
					if (dropBranch != null) {
						toFile = FilePicker2.getDirectoryPath(dropBranch[dropBranch.length-1]) + FilePicker2.getSeparator() + fileName;
					}
				}
				if (toFile == null) {
					dropBranch = DragAndDrop1.getDroppedBranch(FilePicker1.List1);
					if (dropBranch != null) {
						toFile = FilePicker1.getDirectoryPath(dropBranch[dropBranch.length-1]) + FilePicker1.getSeparator() + fileName;
					} else {
						dropBranch = DragAndDrop1.getDroppedBranch(FilePicker2.List1);
						if (dropBranch != null) {
							toFile = FilePicker2.getDirectoryPath(dropBranch[dropBranch.length-1]) + FilePicker2.getSeparator() + fileName;
						}
					}
				}
				
				if (fromFile != null && toFile != null) {
					user.mainmsg.setStatusMsg("Copy " + fromFile + " to " + toFile + ".",10);
				//	CopyFile(fromFile, toFile);
				}
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		FilePicker1.setDragKey("Files");
		FilePicker1.setDragPanel(DragAndDrop1);
		FilePicker1.setDropMessage("Drop here to copy the selected class to this folder");
		FilePicker2.clearFilter();
		FilePicker1.addFilter("Java Class Files", ".class");
		FilePicker1.addFilter("Java Source Files", ".java");
		FilePicker1.addFilter("JDP Applications", ".jdp");
		FilePicker1.loadFiles(user.getJDPDir(), false);
		FilePicker2.setDragPanel(DragAndDrop1);
		FilePicker2.clear();
		FilePicker2.setDragKey("Files");
		FilePicker2.setDropMessage("Drop here to copy the selected class to this folder");
		FilePicker2.clearFilter();
		FilePicker2.addFilter("Java Class Files", ".class");
		FilePicker2.addFilter("Java Source Files", ".java");
		FilePicker2.addFilter("JDP Applications", ".jdp");
		FilePicker2.loadFiles(user.getJDPDir(), false);		
		FilePicker2.loadAllDrives();
	}

}

